Unit AM20R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AM20R(var IA :Array of Integer; var JA :Array of Integer;
                var AN :Array of Real; var B :Array of Real;
                N :Integer; M :Integer; var C :Array of Real); 
implementation

procedure AM20R(var IA :Array of Integer; var JA :Array of Integer;
                var AN :Array of Real; var B :Array of Real;
                N :Integer; M :Integer; var C :Array of Real);
var
I,IAA,IAB,K,J :Integer;
Z :Real;
label
_10,_20,_30;
begin

{           - }
{       -     ,  }
{         RR()U.  -,   }
{        ,      }
{       . }


{   I, J, N -          }
{                 RR()U; }

{             -     N,  }
{                   -; }

{            N -      (: ); }

{             -      (: ); }

{             -     ,  }
{                  -                    }


{           }

for I:=1 to M do
 begin
_10:
  C[I-1] := 0.0;
 end;

{            }

for I:=1 to N do
 begin
  IAA := IA[I-1];
  IAB := IA[I+0]-1;
  if ( IAB < IAA ) 
   then goto _30;

{        I -    I   }
{      ,     }

  Z := B[I-1];
  for K:=IAA to IAB do
   begin
    J := JA[K-1];
_20:
    C[J-1] := C[J-1]+AN[K-1]*Z;
   end;
_30:
 end;
end;

end.
